#!/bin/bash

has_service () {
	if [[ $(systemctl list-units --all -t service --full --no-legend "$1.service" | sed 's/^\s*//g' | cut -f1 -d' ') == "$1.service" ]]; then echo true; else echo false; fi
}

is_docker_running () {
	if curl -s --unix-socket /var/run/docker.sock http/_ping 2>&1 >/dev/null
	then
	  echo "true"
	else
	  echo "false"
	fi
}

has_docker_service=$(has_service docker)
docker_was_running="false"

if [[ $has_docker_service == "true" ]] ; then
	docker_was_running=$(is_docker_running)
	
	# Stop Docker
	echo "Stop Docker"
	systemctl stop docker docker.socket
	echo "Docker stoped"
fi



echo "Empty rules"
# Vider les tables actuelles
iptables -t filter -F

# Vider les règles personnelles
iptables -t filter -X

# Interdire toute connexion entrante et sortante
echo "Enter black holle : drop all"
iptables -t filter -P INPUT DROP
iptables -t filter -P FORWARD DROP
iptables -t filter -P OUTPUT DROP

# ---

# Ne pas casser les connexions etablies
iptables -A INPUT -m state --state RELATED,ESTABLISHED -j ACCEPT
iptables -A OUTPUT -m state --state RELATED,ESTABLISHED -j ACCEPT

# Autoriser loopback
iptables -t filter -A INPUT -i lo -j ACCEPT
iptables -t filter -A OUTPUT -o lo -j ACCEPT

# ICMP (Ping)
iptables -t filter -A INPUT -p icmp -j ACCEPT
iptables -t filter -A OUTPUT -p icmp -j ACCEPT

# DNS In/Out
iptables -t filter -A OUTPUT -p tcp --dport 53 -j ACCEPT
iptables -t filter -A OUTPUT -p udp --dport 53 -j ACCEPT
iptables -t filter -A INPUT -p tcp --dport 53 -j ACCEPT
iptables -t filter -A INPUT -p udp --dport 53 -j ACCEPT
echo "DNS Back"

# NTP Out
iptables -t filter -A OUTPUT -p udp --dport 123 -j ACCEPT
echo "NTP Back"

# ---

{% for port in input_ports  %}
iptables -t filter -A INPUT -p tcp --dport {{ port }} -j ACCEPT
iptables -t filter -A INPUT -p udp --dport {{ port }} -j ACCEPT

{% endfor %}

{% for port in output_ports %}
iptables -t filter -A OUTPUT -p tcp --dport {{ port }} -j ACCEPT
iptables -t filter -A OUTPUT -p udp --dport {{ port }} -j ACCEPT

{% endfor %}

# ---

# IPv6 policies
ip6tables -P INPUT DROP
ip6tables -P OUTPUT DROP
ip6tables -P FORWARD DROP


# Ne pas casser les connexions etablies
ip6tables -A INPUT -m state --state RELATED,ESTABLISHED -j ACCEPT
ip6tables -A OUTPUT -m state --state RELATED,ESTABLISHED -j ACCEPT

# Autoriser loopback
ip6tables -t filter -A INPUT -i lo -j ACCEPT
ip6tables -t filter -A OUTPUT -o lo -j ACCEPT

# ICMP (Ping)
ip6tables -t filter -A INPUT -p icmp -j ACCEPT
ip6tables -t filter -A OUTPUT -p icmp -j ACCEPT

# DNS In/Out
ip6tables -t filter -A OUTPUT -p tcp --dport 53 -j ACCEPT
ip6tables -t filter -A OUTPUT -p udp --dport 53 -j ACCEPT
ip6tables -t filter -A INPUT -p tcp --dport 53 -j ACCEPT
ip6tables -t filter -A INPUT -p udp --dport 53 -j ACCEPT
echo "DNS Back"

# NTP Out
ip6tables -t filter -A OUTPUT -p udp --dport 123 -j ACCEPT
echo "NTP Back"

{% for port in ipv6_input_ports  %}
ip6tables -t filter -A INPUT -p tcp --dport {{ port }} -j ACCEPT
ip6tables -t filter -A INPUT -p udp --dport {{ port }} -j ACCEPT
{% endfor %}

{% for port in ipv6_output_ports %}
ip6tables -t filter -A OUTPUT -p tcp --dport {{ port }} -j ACCEPT
ip6tables -t filter -A OUTPUT -p udp --dport {{ port }} -j ACCEPT
{% endfor %}

if [[ $has_docker_service == "true" ]] && [[ $docker_was_running == "true" ]] ; then
	# Relaunch dockers rules
	echo "Start Docker"
	systemctl start docker docker.socket
	echo "Docker started"
fi
